
ChiliProject - Bug # 887: Stacked month (top row)

Status: Closed Priority: Normal
Author: Tom Rochette Category: Gantt chart
Created: 2012-02-15 Assignee: Felix Schäfer
Updated: 2012-04-04 Due date:
Remote issue URL:
Affected version: 3.0.0
Description: The top row of the gantt chart which represents each month is somehow stacked when you have more than 1 

month to be displayed instead of displaying properly like in the previous 2.X releases.

See the screenshot for a visual presentation of the problem.

This applies to both Google Chrome 17 as well as Firefox 10.

Associated revisions
2012-04-04 09:36 am - Felix SchÃ¤fer 
Correct handling of @Rational#to_s@ on ruby 1.9 #887

Contributed by Martin S

History
2012-04-01 06:26 pm - Martin S
i just fixed that bug in my local copy.

There are some to_i missing in the gantt view calculation.

<pre>
--- a/app/views/gantts/show.html.erb
+++ b/app/views/gantts/show.html.erb
@@ -98,13 +98,13 @@ month_f = @gantt.date_from
 left = 0
 height = (show_weeks ? header_heigth : header_heigth + g_height)
 @gantt.months.times do
-       width = ((month_f >> 1) - month_f) * zoom - 1
+       width = (((month_f >> 1) - month_f) * zoom - 1).to_i
        %>
        <div style="left:<%= left %>px;width:<%= width %>px;height:<%= height %>px;" class="gantt_hdr">
        <%= link_to h("#{month_f.year}-#{month_f.month}"), @gantt.params.merge(:year => month_f.year, :month => month_f.month), :title => 
"#{month_name(month_f.month)} #{month_f.year}"%>
        </div>
        <%
-       left = left + width + 1
+       left = (left + width + 1).to_i
        month_f = month_f >> 1

</pre>

2012-04-03 06:04 am - Felix Schäfer
I can't reproduce this (on master). Could you have a look at the source and see what @style@ values the month boxes have?

2012-04-03 01:11 pm - Tom Rochette
Source looks like (for a single date item):
<pre>
<div class="gantt_hdr" style="left:2448/1px;width:479/1px;height:18px;">
<a title="September 2012" href="/projects/p/issues/gantt?month=9&months=6&year=2012&zoom=4">2012-9</a>
</div>
</pre>

There's obviously something wrong with the inline div style...

2012-04-03 02:32 pm - Felix Schäfer
- Status changed from Open to Needs more information

Tom Rochette wrote:
> There's obviously something wrong with the inline div style...

Indeed. Do you have more info about your setup? (Ruby? Server? â€¦) I'd like to know the cause of this before fixing it :-)

2012-04-04 01:12 am - Tom Rochette
Felix SchÃ¤fer wrote:
> Tom Rochette wrote:
> > There's obviously something wrong with the inline div style...
> 
> Indeed. Do you have more info about your setup? (Ruby? Server? â€¦) I'd like to know the cause of this before fixing it :-)

Absolutely:
* Ruby 1.9.3p30
* Rails 2.3.14
* ChiliProject 3.0.0.11e93ff36 (using mysql2 adapter)
* Thin 1.3.1

If you need anything else... Ask :)

2012-04-04 07:33 am - Felix Schäfer
- Status changed from Needs more information to Open

Tom Rochette wrote:
> * Ruby 1.9.3p30

It seems that's the gist of the problem, ruby 1.8 and 1.9 print @Rational@ s out differently. On 1.8:

<pre>>> Rational(29,1).to_s
=> "29"</pre>

On 1.9:

<pre>>> Rational(29,1).to_s
=> "29/1"</pre>

2012-04-04 07:40 am - Felix Schäfer
- Status changed from Open to Closed
Fixed in commit:0a7c6e6, thanks!

2012-04-04 08:01 am - Holger Just
- Target version set to 3.1.0

- Assignee set to Felix Schäfer

2012-04-04 01:15 pm - Tom Rochette
Confirmed fixed @ 3.1.0 in Firefox 11.

2012-04-04 01:50 pm - Felix Schäfer
Tom Rochette wrote:
> Confirmed fixed @ 3.1.0 in Firefox 11.

You're fast ;-) Thanks for the feedback!
